<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

/**
 * WorthstockFrontend è la classe che gestisce l'integrazione in Admin tra le pagine di editing dei prodotti WooCommerce e WORTHSTOCK: metabox nella pagina di edit di un prodotto e colonne custom e bulk action nella pagina di elenco prodotti
 */
class WorthstockFrontend extends WorthstockBase {
    
	public $main;

    public function __construct()
    {
        //$this->main = $GLOBALS['worthstock_obj'];        
    }

    protected function create_ajax_hooks() {

    }

    public function enqueue_scripts()
    {
    }

    protected function init() {

    }

    
    public function ajax_do_action()
    {
        //global $worthstock_obj;
        $worthstock_obj = $this->main();
        if ( ! wp_verify_nonce($_REQUEST['_nonce'], 'ws-nonce')) {
            wp_send_json_error(['message'=>'invalid_nonce']);
        }

        $action = $_REQUEST['action'];
        $caller = $_REQUEST['caller'];
        
	    $token ="79Y+yM16N2RHRrNUxwdGWco9gCJr1oGTrnSnuZZC7jQ+VNSpRDGd79tZAZx1ZSbfzugF+RnzQaGdNYbsCZI\/dw==";
        $product_id = '2';
        $id_product = ($_REQUEST['id_product']) ? $_REQUEST['id_product'] : null;

        switch($caller) {
            case 'api_login':
                $worthstock_obj->sync->api_login(true);
                break;

            case 'get_single_product':
                $worthstock_obj->sync->api_get_single_product($token, $product_id);
                break;
                
            case 'get_all_products':
                $worthstock_obj->sync->api_get_all_products($token);
                break;
                
            case 'get_categories':
                $worthstock_obj->sync->api_get_categories($token);
                break;

            /* currently unused */
            case 'get_all_products_published':
                $worthstock_obj->sync->api_get_all_products_drafted($id_product);
                break;

            case 'erase_plugin_metadata':
                $worthstock_obj->ui->erase_plugin_metadata();
                break;

            default:
                break;
        }        
        
        wp_send_json_success(["action" => $action], 200);
    }
    

    /**
     * print product custom meta fields imported from worthstock
     */
    public function product_print_custom_meta() {
        $params = $this->main()->mapper->getWorthstockFullCustomParamList();
        $product_id = get_the_ID();
        
        $product = wc_get_product( $product_id );
        
	    echo '<div class="options_group">';
        echo '<h4 style="margin: 20px 0 20px 160px;">WORTHSTOCK</h4>';
        foreach($params as $label => $field) {
            $custom_attributes = ($field["readonly"] == true ? array('readonly' => 'readonly') : []);
            $field["description"] = null;
            $value = $this->main()->mapper->readWorthstockCustomParamValue($product_id, $label);
            $value = ($value === false && $field["selected"] === true) ? 1 : $value;
            if ($label == "IdProduct") {
                $value = get_post_meta($product_id, $this->main()->mapper->getWorthstockCustomParamName($field["name"]));
                if ( is_array($value) ) {
                    $value = join(",", $value);
                }
            }
            if ($label == "FlagEcommerce") {                
                // se il prodotto è privato, il flag di visibilità su WS deve essere impostato come false
                if ( $product->get_status() == 'private' || !$product->is_visible() ) {
                    $custom_attributes = array('readonly' => 'readonly', 'onclick' => 'return false;', 'onkeydown' => 'return false;');
                    $field["description"] = __('(il prodotto non sarà visibile in quanto impostato a privato)', 'woocommerce' );
                }
            }
            if ($field["type"] == "bool") {
                woocommerce_wp_checkbox(
                    array(
                        'id'            => $field["name"],
                        'value'         => $value,
                        'label'         => $field["fullname"],
                        'cbvalue'       => 1,
                        'description'   =>  $field["description"],
                        'custom_attributes' => $custom_attributes
                    )
                );
            } else {
                woocommerce_wp_text_input(
                    array(
                        'id'            => $field["name"],
                        'value'         => $value,
                        'label'         => $field["fullname"],
                        'custom_attributes' => $custom_attributes
                    )
                );
            }
        }
        
	    echo '</div>';
    }
    

    /**
     * save product custom meta fields imported from worthstock
     */
    public function product_save_custom_meta($post_id)
    {
    //     if ( ! ( isset( $_POST['woocommerce_meta_nonce'] ) || wp_verify_nonce( sanitize_key( $_POST['woocommerce_meta_nonce'] ), 'woocommerce_save_data' ) ) ) {
    //         return false;
    //     }
        
    //     $product_teaser = sanitize_text_field(
    //             wp_unslash( $_POST[ $this->textfield_id ] )
    //     );
        $params = $this->main()->mapper->getWorthstockFullCustomParamList();
        foreach($params as $key=>$value) {
            $value_name = $value["name"];
            $data = esc_attr($_POST[$value_name]);
            if ( $value["type"] == "bool" ) {
                $data = ($data ? $data : 0);
            }
            if ( isset($data) && ($data !== -1)) {
            //if ( isset($_POST[$value]) ) {                
                if ($key == "IdProduct") {
                    $data = explode(",",$data);
                    delete_post_meta($post_id, $this->main()->mapper->getWorthstockCustomParamName('id_product'));
                    if (is_array($data)) {
                        foreach ($data as $id) {
                            add_post_meta( $post_id, $this->main()->mapper->getWorthstockCustomParamName('id_product'), $id);
                        }
                    }
                } else {
                    update_post_meta($post_id, $this->main()->mapper->getWorthstockCustomParamName($value_name), $data);
                }
            }
        }
    }

    /**
     * custom meta della variation
     */
    function variation_print_custom_meta( $loop, $variation_data, $variation ) {
        //$idVariation = get_post_meta( $variation->ID, '_wst_id_product_variant', true );
        woocommerce_wp_text_input(
            array(
                'id'            => "_id_product{$loop}",
                'name'          => "_id_product[{$loop}]",
                'value'         => $this->main()->mapper->readWorthstockCustomParamValue($variation->ID, 'IdProduct', "variant"),
                'label'         => __( 'WORTHSTOCK product id', 'woocommerce' ),
                'desc_tip'      => true,
                'description'   => __( 'ID del prodotto WORTHSTOCK collegato (IdProduct)', 'woocommerce' ),
                'wrapper_class' => 'form-row form-row-full',
                'custom_attributes' => array('readonly' => 'readonly')
            )
        );
        woocommerce_wp_text_input(
            array(
                'id'            => "_id_product_variant{$loop}",
                'name'          => "_id_product_variant[{$loop}]",
                'value'         => $this->main()->mapper->readWorthstockCustomParamValue($variation->ID, 'IdProductVariant', "variant"),
                'label'         => __( 'WORTHSTOCK variant id', 'woocommerce' ),
                'desc_tip'      => true,
                'description'   => __( 'ID con cui la variante è presente nel DB WORTHSTOCK (IdVariant)', 'woocommerce' ),
                'wrapper_class' => 'form-row form-row-full',
                'custom_attributes' => array('readonly' => 'readonly')
            )
        );
        //$_unique_id_shopify = get_post_meta( $variation->ID, '_unique_id_shopify', true );
        woocommerce_wp_text_input(
            array(
                'id'            => "_unique_id_shopify{$loop}",
                'name'          => "_unique_id_shopify[{$loop}]",
                'value'         => $this->main()->mapper->readWorthstockCustomParamValue($variation->ID, 'UniqueIdShopify', "variant"),
                'label'         => __( 'WORTHSTOCK Unique Variant Id', 'woocommerce' ),
                'desc_tip'      => true,
                'description'   => __( '(UniqueIdShopify)', 'woocommerce' ),
                'wrapper_class' => 'form-row form-row-full',
                'custom_attributes' => array('readonly' => 'readonly')
            )
        );
    }

    
    function variation_save_custom_meta( $variation_id, $loop ) {
        $text_field = $_POST['my_text_field'][ $loop ];

        if ( ! empty( $text_field ) ) {
            update_post_meta( $variation_id, 'my_text_field', esc_attr( $text_field ));
        }
    }
    
    /** don't touch this, or remove before the filter associated "woocommerce_available_variation" */
    function variation_load_custom_meta( $variation ) {     
        $variation['_wst_id_product_variant'] = get_post_meta( $variation[ 'variation_id' ], '_wst_id_product_variant', true );

        return $variation;
    }    
	
	public function product_admin_footer() {
        $this->output_json_modal();
        //$this->output_custom_js();
	}

    public function product_custom_meta_box()
    {
        add_meta_box(
            'custom_product_meta_box',
            __( 'Integrazione WORTHSTOCK', 'worthstock' ),
            array($this, 'product_custom_content_meta_box'),
            'product',
            'side',
            'default'
        );
    }

    //  Custom metabox content in admin product pages
    public function product_custom_content_meta_box( $post ) {
        echo '<div style="text-align: center; padding-top: 10px;">';        
        if ( $this->main()->mapper->isProductSynced($post) ) {
            $worthstock_logo = WORTHSTOCK__PLUGIN_DIR . 'inc/img/worthstock-logo.png';
            if (file_exists($worthstock_logo)) {
                echo '<img style="width: 80%; height:auto;" alt="worthstock logo" src="' . WORTHSTOCK__PLUGIN_URL . 'inc/img/worthstock-logo.svg'. '">';
            }
            echo '<p>'.__( 'La scheda prodotto è sincronizzata con WORTHSTOCK', 'worthstock' ).'</p>';
        }
        if ( $last_operation = $this->main()->sync->read_product_last_operation($post->ID)) {
            echo '<p>' . __( 'Ultima operazione: ', 'worthstock' ) . $last_operation[0] . (wp_date( get_option( 'date_format' ), $last_operation[1] ) ? ' at ' . wp_date( 'd m Y H:i:s', $last_operation[1] ) : '') . ' ' . ($last_operation[2] ?? '') . '</p>';
        }
        /*
        ?>
            <p><a href="#" id="ws-real-prodotto-check" class="">Check real prodotto</a></p>
        <?php
        */
        if ($this->main()->settings->get_option( 'worthstock_debug_flag' ) == 'yes' ) {
            add_thickbox();
            ?>
            <a href="#TB_inline?height=550&inlineId=modal-window-product-json" class="thickbox">Visualizza json prodotto</a>
        <?php 
        }
        
        echo '</div>';
    }

    protected function output_json_modal() {
        global $post;
        if ( !is_admin() || $this->main()->settings->get_option( 'worthstock_debug_flag' ) !== 'yes' || ( get_post_type( $post->ID ) != 'product' ) ) {
            return null;
        }
        ?>

        <div id="modal-window-product-json" style="display:none;">
            <h4>JSON DI RICHIESTA PER QUESTO PRODOTTO</h4>
            <div>
            <?php
            $action_type = ($this->main()->mapper->isProductSynced($post)) ? 'update' : 'insert';
            @$data = $this->main()->mapper->convertProductToWorthstock($post->ID, $action_type);
            @$stats = $this->main()->mapper->getWSProductStats($data);
            @$data = $this->main()->sync->prepare_product_json('update', $data, true);
            if ($data) {
                if ( is_array($data) ) {
                    $data = json_encode($data, JSON_PRETTY_PRINT);
                }
                echo "<p>Numero di prodotti WORTHSTOCK corrispondenti: ".$stats['ProductsNumber']."</p>";
                echo "<p>Numero di varianti WORTHSTOCK corrispondenti: : ".$stats['VariantsNumber']."</p>";
                echo "<pre>" . $data . "</pre>";               
            }
            ?>
        </div>
        </div>
        <style>
            pre {
                white-space: pre-wrap;       /* Since CSS 2.1 */
                white-space: -moz-pre-wrap;  /* Mozilla, since 1999 */
                white-space: -pre-wrap;      /* Opera 4-6 */
                white-space: -o-pre-wrap;    /* Opera 7 */
                word-wrap: break-word;       /* Internet Explorer 5.5+ */
            }            

            #TB_window #TB_ajaxContent {
                height: 90% !important;
                overflow: auto !important;
            }
        </style>
        <?php
    }

    protected function output_custom_js() {
        ?>
        <script>
        (function ($) {
            $(document).ready(() => {
                $('a#ws-real-prodotto-check').click(function (e) {
                    e.preventDefault();
                    if ( !confirm('Vuoi continuare?') ) return false;
                });
            });
        })(jQuery);
        </script>
        <?php
    }

    public function product_custom_bulk_hooks( $current_screen ) {
        if( current_user_can( 'administrator' ) ) {
            add_filter( 'bulk_actions-edit-product', array($this, 'register_bulk_actions') );
            add_filter( 'handle_bulk_actions-edit-product', array($this, 'bulk_action_handler_worthstok'), 10, 3 );
            add_action( 'admin_notices',  array($this, 'bulk_action_admin_notice') );
		    add_action( 'admin_footer', array( &$this, 'product_admin_footer' ) );
		    add_action( 'admin_print_scripts-edit.php', array( &$this, 'product_is_ws_css' ) );            
            
            add_filter( 'manage_edit-product_columns',  array( &$this, 'product_is_ws_synced'), 20 );
            add_action( 'manage_product_posts_custom_column',  array( &$this, 'product_ws_synced_column_data'), 2 );

            add_filter( 'manage_edit-product_sortable_columns', array( &$this, 'set_wp_synced_sortable_columns') );
            add_filter( 'request', array( &$this, 'wp_synced_column_orderby') );
            /* if ( 'product' == $current_screen->post_type && 'post' === $current_screen->base ) {
                add_action('admin_enqueue_scripts', array($this->main(), 'worthstock_import_script_and_style'));
            } */
        }
    }   

    //Register
    public function register_bulk_actions($bulk_actions) {
        $bulk_actions['enqueue_send_to_worthstock'] = __( 'Esporta su WORTHSTOCK', 'worthstock');
        return $bulk_actions;
    }

    //Handle 
    public function bulk_action_handler_worthstok( $redirect_to, $doaction, $post_ids ) {
        if ( $doaction !== 'enqueue_send_to_worthstock' ) {
            return $redirect_to;
        }
        foreach ( $post_ids as $product_id ) {
            // Perform action for each product
            $this->main()->queue->add_event_to_queue('update', $product_id);
        }
        $redirect_to = add_query_arg( 'bulk_sent_products', count( $post_ids ), $redirect_to );
        return $redirect_to;
    }

    //Notices
    public function bulk_action_admin_notice() {
        if ( ! empty( $_REQUEST['bulk_sent_products'] ) ) {
            $product_count = intval( $_REQUEST['bulk_sent_products'] );
            printf( '<div id="message" class="updated fade">' .
            _n( '%s prodotto sincronizzato con WORTHSTOCK',
                '%s prodotti sincronizzati con WORTHSTOCK',
                $product_count,
                'worthstock'
            ) . '</div>', $product_count );
        }
    }

    // Add product new column in administration
    function product_is_ws_synced( $columns ) {
        foreach ($columns as $key => $val) {
            if ($key == 'name') {
                $new_columns['worthstock_synced'] = esc_html__( 'WORTHSTOCK', 'worthstock' );
                $new_columns[$key] = $val;
            } else {
                $new_columns[$key] = $val;
            }
        }
        return $new_columns;
    }

    function product_is_ws_css() {
        ?>
        <style type="text/css">
            table.wp-list-table .column-worthstock_synced { width: 15ch; }
        </style>
        <?php
    }

    // Populate weight column
    function product_ws_synced_column_data( $column ) {
        global $post;

        if ( $column == 'worthstock_synced' ) {
            if ( $this->main()->mapper->isProductSynced($post) ) {
            #if ( $id_worthstock = get_post_meta($post->ID, '_wst_id_product', true) ) {
                
                _e( 'Sincronizzato', 'worthstock' );
            } else {
                print '-';
            }
        }
    }

    // make column sortable
    function set_wp_synced_sortable_columns( $columns )
    {
        $columns['worthstock_synced'] = 'worthstock_synced';
        return $columns;
    }

    // sorting function
    function wp_synced_column_orderby( $vars ) {
        if ( isset( $vars['worthstock_synced'] ) && 'worthstock_synced' == $vars['orderby'] ) {
            $vars = array_merge( $vars, array(
                'meta_key' => '_wst_id_product',
                //'orderby' => 'meta_value_num', // does not work
                'orderby' => 'meta_value'
                //'order' => 'asc' // don't use this; blocks toggle UI
            ) );
        }
        return $vars;
    }

    public function erase_plugin_metadata() {
        // cancello post_meta_data del prodotto
        $this->main()->sync->remove_product_metadata(44445);

        // rimuovo i setting del plugin
        // delete_option( 'worthstock-settings' );
        
        $message = "I metadata associati al plugin WORTHSTOCK SONO STATI RIMOSSI";        
        $this->main()->sync->api_logger($message);
        print (json_encode(["success" => true,"data" => array("message" => $message)]));
        wp_die();
    }

}